<template>
  <div class="flex flex-col items-start h-full pl-8 pt-5">
    <div class="flex items-center mb-6">
      <h2 class="max-w-none">Suchergebnis</h2>
      <div
        v-if="total > 0"
        class="bg-transparent ml-3 h-8 border-primary-400 text-primary-500 font-semibold text-xs p-2 border rounded leading-loose flex justify-center items-center"
      >{{total}} Treffer</div>
    </div>
    <div class="flex-1 overflow-y-hidden w-full">
      <DataTable
        :loading="loading"
        :value="monasteries"
        scrollable
        scrollHeight="flex"
        @row-click="rowClick"
      >
        <template #empty>Keine Klöster gefunden</template>
        <template #loading>
          <div class="w-full h-full pr-4">
            <Skeleton height="2.5rem" class="mb-2"/>
            <Skeleton height="3rem" class="mb-1" v-for="i in Array(15)" />
          </div>
        </template>
        <Column header="GSN" field="gsnId"></Column>
        <Column header="Klostername">
          <template #body="scope">
            <p class="font-semibold">{{scope.data.name}}</p>
            <p v-if="scope.data.volumeNumber.length > 0" class="font-normal italic text-gray-500 text-xs">Germania Sacra Band: {{scope.data.volumeNumber[0]}}</p>
          </template>
        </Column>
        <Column header="Zeitraum" field="orderTimeRange">
          <template #body="scope">
            <div class="value">{{scope.data.orderTimeRange}}</div>
          </template>
        </Column>
        <Column header="Ort" field="places">
          <template #body="scope">
            <div class="flex flex-wrap">
              {{scope.data.places}}
            </div>
          </template>
        </Column>
        <Column header="Patrozinium">
          <template #body="scope">
            <div class="flex">
              <div class="flex-shrink overflow-hidden flex flex-wrap mr-4">
                <div v-if="scope.data.patrocinium && scope.data.patrocinium !== ''">
                  <span>{{scope.data.patrocinium}}</span>
                </div>
                <span v-else>-</span>
              </div>
            </div>
          </template>
        </Column>
      </DataTable>

    </div>
    <div class="w-full flex justify-center mb-3 mt-1">
      <Paginator
        :first="first"
        :rows="limit"
        :totalRecords="total"
        :pageLinkSize="7"
        template="FirstPageLink PrevPageLink PageLinks NextPageLink LastPageLink JumpToPageDropdown"
        @page="onPageChange"
        :pt="{
          root: {
            class: 'text-sm'
          },
        }"
      />
    </div>
  </div>
</template>

<script>
export default {
  name: 'MonasteriesList',
  computed: {
    monasteries () {
      return this.$store.state.monasteriesList.map(item => ({
        ...item,
        orderTimeRange: item.orderTimeRange.join(' - '),
        places: item.locations.map(loc => loc.placeName).join(', '),
      }));
    },
    total () {
      return this.$store.state.monasteriesListTotalNumber;
    },
    limit () {
      return this.$store.state.monasteriesQuery.limit;
    },
    loading () {
      return this.$store.state.loadingList;
    },
    page: {
      get: function () {
        return this.$store.state.page;
      }
    },
    first() {
      return this.limit * this.page;
    }
  },
  watch: {
    total () {
      this.$store.dispatch('setPage', 0);
    },
  },
  methods: {
    rowClick ({ data }) {
      this.$router.push({ path: '/gsn/' + data.gsnId });
    },
    onPageChange ({ page, first }) {
      const offset = this.limit * page;
      this.$store.dispatch('getMonasteriesList', { offset });
      this.$store.dispatch('setPage', page);
    },
    getSpan ({ row, column, rowIndex, columnIndex }) {
      const rowSpan = 1;
      let colSpan = 1;

      if (columnIndex === 0) colSpan = 2;
      return [rowSpan, colSpan];
    },
  },
};
</script>

<style lang="scss">
svg {
  display: inline-block;
}

.p-datatable {
  font-size: 1rem;
  @apply bg-transparent;

  &-table-container {
    @apply pr-4 pl-[3px];
  }

  &-table {
    @apply border-separate border-spacing-y-1.5 !important;
  }

  &__header-wrapper {
    @apply relative z-10;
  }
  &-thead {
    @apply mb-2;

    th {
      @apply bg-gray-200 py-2 text-sm font-bold;
      &:first-child { border-top-left-radius: 6px; border-bottom-left-radius: 6px; @apply text-right; }
      &:last-child { border-top-right-radius: 6px; border-bottom-right-radius: 6px; }
      &.gutter {
        width: 0 !important;
        display:none;
      }
    }
  }

  tbody {
    padding-right: calc(2rem - 12px);
    @apply -mt-2;
     > tr {
      @apply cursor-pointer bg-white transition text-sm duration-200 pb-2 rounded shadow;
      &:hover, &:focus {
        @apply relative z-10 bg-white shadow-xl outline outline-1 outline-offset-0 outline-primary-200 transition-colors;
        // box-shadow: 0 4px 6px -1px rgba(158, 19, 30, 0.2), 0 2px 4px -1px rgba(158, 19, 30, 0.06);
        > td {
          background: none !important;
        }
      }
      > td:first-child { border-top-left-radius: 6px; border-bottom-left-radius: 6px; }
      > td:last-child { border-top-right-radius: 6px; border-bottom-right-radius: 6px; overflow: hidden; }
      > td:not(:nth-child(2)) { @apply text-gray-500; }

      > td {
        @apply bg-white text-gray-800 py-4;
        vertical-align: top;
        .cell {
          word-break: break-word;
        }

        &:nth-child(1) {
          .cell {
            @apply text-right;
          }
        }

        &:nth-child(3) {
          @apply text-sm pr-6;
        }
      }
    }
  }
}

.p-datatable-mask {
  background: none !important;
}

.p-paginator-page,
.p-paginator-first,
.p-paginator-prev,
.p-paginator-next,
.p-paginator-last {
  min-width: 35px !important;
  height: 35px !important;
}
.p-paginator-content {
  height: 35px !important;
}
.p-paginator-page.p-paginator-page-selected {
  @apply border border-solid border-primary-500;
}

.p-paginator-page:not(.p-disabled):not(.p-paginator-page-selected):hover,
.p-paginator-first:not(.p-disabled):hover,
.p-paginator-prev:not(.p-disabled):hover,
.p-paginator-next:not(.p-disabled):hover,
.p-paginator-last:not(.p-disabled):hover {
  @apply bg-gray-200 #{!important};
}

.p-select-label {
  line-height: 1;
}
</style>
